package jeliot.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  * @author Pekka Uronen
  *
  * NOT CURRENTLY USED IN JELIOT!
  *
  * created         11.8.1999
  */
public class DraggableComponent extends JPanel implements MouseListener,
        MouseMotionListener {

    final static int FREE   = 0;
    final static int DRAG   = 1;
    final static int RESIZE = 2;
    final static int FIXED  = 3;
    
    int mode = FREE;
    Point dragPoint;
    Dimension origSize;

    protected DraggableComponent() {
        addMouseListener(this);
        addMouseMotionListener(this);
        
        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    }

    
    boolean inStretchArea(Point p) {
        Dimension d = getSize();
        return (p.x > d.width - 8) && (p.y > d.height-8);
    }

    public void mousePressed(MouseEvent e) {
        dragPoint = new Point(e.getX(), e.getY());
        origSize = getSize();
        mode = inStretchArea(dragPoint) ? RESIZE : DRAG;
       
        repaint();
    }

    public void mouseDragged(MouseEvent e) {
        switch (mode) {
            case (DRAG):
                Point loc = getLocation();
                loc.translate(e.getX(), e.getY());
                loc.translate(-dragPoint.x, -dragPoint.y);
                setLocation(loc);
                break;
            case (RESIZE):
                int w = e.getX() - dragPoint.x + origSize.width;
                int h = e.getY() - dragPoint.y + origSize.height;
                setSize(w, h);
                break;
        }
                
    }

    public void mouseReleased(MouseEvent e) {
        mode = FREE;
        revalidate();
    }
    
    public boolean isFree() {
        return mode == FREE;
    }

    public void mouseClicked(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseMoved(MouseEvent e) {}
}
