package jeliot.lang;

import java.lang.reflect.*;
import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created 30.9.1999
  */
public class ForeignFieldPointer extends FieldPointer {

    private Field myField;

    public ForeignFieldPointer(Field field) {
        this.myField = field;
    }
    
    /** Returns the type of this field.
      */
    public Type getType() {
        return Type.getTypeByClass(myField.getType());
    }
    
    public Type getDeclaringClass() {
        return Type.getTypeByClass(myField.getDeclaringClass());
    }
    
    /** Returns true if this field is declared as static.
      */
    public boolean isStatic() {
        return Modifier.isStatic(myField.getModifiers());
    }
    
    /** Returns true if this is a private field.
      */
    public boolean isPrivate() {
        return Modifier.isPrivate(myField.getModifiers());
    }
        
    /** Returns the return value of the field.
      */
    public Variable access(Director dir) {
        return null;    
    }
    
}
