package jeliot.lang;

import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created 24.8.1999
  */
public abstract class MethodPointer {

    /** Returns the return type of this method.
      */
    public abstract Type getReturnType();
    
    /** Returns true if this method is declared as static.
      */
    public abstract boolean isStatic();
    
    /** Returns true if this method is a private method.
      */
    public abstract boolean isPrivate();
    
    /** Invokes the pointed method and returns the return value of
      * the invocation.
      */
    public abstract Return invoke(Instance ins, Value[] args,
            PMethodInvocation invo, Director dir);
            
    public abstract ReferenceType getDeclaringClass();
    
    public abstract String getName();
}
