package jeliot.lang;

import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * Variable is an instance of a variable - a field or a local
  * variable. A new variable is created runtime every time a local
  * variable is declared.
  *
  * @author Pekka Uronen
  *
  * created         9.8.1999
  * last modified   16.8.1999
  */
public class Variable {

    PVariableDeclarator declarator;
    Value value;
    VariableActor actor;
    Type type;
    String name;

    protected Variable() { };

    Variable(PVariableDeclarator declarator) {
        this.declarator = declarator;
        this.type = declarator.getType();
        this.name = declarator.getIdentifier();
    }

    public void assign(Value value) {
        this.value = value.cast(type);
    }

    public Value getValue() {
        return value;
    }

    public String getName() {
        return name;
    }

    public void setActor(VariableActor actor) {
        this.actor = actor;
    }

    public VariableActor getActor() {
        return actor;
    }

    public Type getType() {
        return type;
    }
    
    protected void setType(Type type) {
        this.type = type;
    }
    
}
