package jeliot.parser;

import java.util.*;
import jeliot.lang.*;
import jeliot.theatre.*;

/***
  * @author Pekka Uronen
  *
  * created         30.8.1999
  */
public abstract class PElement {

    private int left;
    private int right;

    private PElement parent;

    protected PElement(int left, int right) {
        this.left = left;
        this.right = right;
    }

    public PElement() { }
    
    protected void setRightPos(int right) {
        this.right = right;
    }

    protected void setLeftPos(int left) {
        this.left = left;
    }

    public int getLeftPos() {
        return left;
    }

    public int getRightPos() {
        return right;
    }
    
    public PElement getParent() {
        return parent;
    }

    public void setParent(PElement parent) {
        this.parent = parent;
    }

    protected void setParents(Vector vec) {
        if (vec != null) {
            Enumeration enum = vec.elements();
            while (enum.hasMoreElements()) {
                PElement e = (PElement)enum.nextElement();
                e.setParent(this);
            }
        }
    }
   
}
