package jeliot.parser;

import java.util.*;
import jeliot.lang.*;
import jeliot.theatre.*;

/**
  * PExpressionStatement represents a single expression statement.
  *
  * @author Pekka Uronen
  *
  * created         15.8.1999
  * last modified   15.8.1999
  */
public class PExpressionStatement extends PStatement {

    private PExpression expression;

	public PExpressionStatement(PExpression e, int left, int right) {
        super(left, right);
	    this.expression = e;

	    expression.setParent(this);
    }

    public void acceptVisitor(ProgramTreeVisitor visitor) throws SemanticException {
        visitor.visitExpressionStatement(this);
        expression.acceptVisitor(visitor);
    }

    void execute(Director director) {
        director.atStatement(this);
        Scratch scratch = director.openScratch();
        expression.evaluate(director);
        director.closeScratch(scratch);
    }
    
}
