package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * IllegalAccessException is thrown when a type checker finds that
  * the compile time type of a variable access to get variable's field 
  * is a primitive type or void.
  * 
  * @author Pekka Uronen
  *
  * created         30.9.1999
  */
public class IllegalFieldAccessException extends SemanticException {
    
    private PVariableAccessExpr access;
    private Type type;
    
    public IllegalFieldAccessException(Type t, 
            PVariableAccessExpr access) {
        this.access = access;
        this.type = t;
    }
    
    public String toString() {
         String typeStr = type.toString();
         String varName = access.getIdentifier();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>Illegal method invocation.</H1>\n" +
            "<P>" +
            "Your program tries to access field <B>" +
            varName + "</B> in type <B>" + typeStr + "</B>." +
            "There is, however, no fields at all in that type." +
            "</BODY></HTML>"
            );
    }
    
}